﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace _292357_DragDropTreeViewToTreeView
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.treeView1.ItemsSource = this.GenerateData();

			this.treeView1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery), true);
		}

		private ObservableCollection<Company>GenerateData()
		{
			ObservableCollection<Company> result = new ObservableCollection<Company>();

				Company c = new Company() { Name = String.Format("Company") };

				for (int j = 0; j < 6; j++)
				{
					Department d = new Department() { Name = String.Format("Department {0}", j) };

					for (int k = 0; k < 8; k++)
					{
						Employee e = new Employee() { Name = String.Format("Employee {0}", k) };
						d.Employees.Add(e);
					}
					c.Departments.Add(d);
				}
				result.Add(c);
			return result;
		}
		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			RadTreeViewItem item = e.OriginalSource as RadTreeViewItem;
			var dropPosition = item.DropPosition;
			
			if (dropPosition == DropPosition.Inside //checking if the drop position is inside
				&& !item.HasItems //checking if the item has children
				&& item.Level != 0)//checking if the item is the main node
			{
				e.QueryResult = true;
				e.Handled = true;
			}
			else e.QueryResult = false;
		}
	}
}
